program drop _all
pause off
cap log close
log using maxsub2, replace
clear
set more 1
set seed 123456789
set obs 100
gen X = (_n-50)/10
gen y = -2.0 + 3.0 * X + 5*invnorm(uniform())
gen ycn = max(y,0) 
regress y X
* any starting values
gl nlist = "beta:X beta:_cons"
gl yvar = "y"
mat b0 = (.1,5.1)
mat colnames b0 = $nlist
amoeba myols b0 yout bols 
quasi myols bols yout bfinal g h
mat l h
tobit ycn X, ll(0)
gl yvar = "ycn"
predict xb, index
egen tad = sum(abs(ycn-max(xb,0)))
di tad
matrix sig = (3.0)
matrix btob = b0 , sig
* set trace on
amoeba tobin btob yout bq1 . . 1E-5
quasi tobin bq1 yout bfinal g h . . . bhhh
mat l h
gl fvals = 0
amoeba powell b0 yout bpow1 . . 1E-7
di "Number of function evaluations = " $fvals
gl fvals = 0
mat b1 = (.1,5.1)
simplex ycn X, from(b1) lf(powell) iterate(100)
di "Number of function evaluations = " $fvals
log close
